/*Inspired and Modified  quitbutton@azaroth92.hotmail.it and lgbutton@atomant */
const Gio       = imports.gi.Gio;
const GLib      = imports.gi.GLib;
const Lang      = imports.lang;
const Main      = imports.ui.main;
const Panel     = imports.ui.panel;
const PanelMenu = imports.ui.panelMenu;
const St        = imports.gi.St;

const ROLE = 'Shutdownbtn'

const userMenuButton = imports.ui.main.panel._statusArea['userMenu'];
const GnomeSession = imports.misc.gnomeSession;

let ShutdownBTN;
let _Session = new GnomeSession.SessionManager();

function ShutdownButton() {
    this._init.apply(this, arguments);
}

ShutdownButton.prototype = {
    __proto__: PanelMenu.ButtonBox.prototype,

    _init: function(metadata, params)
    {
        PanelMenu.ButtonBox.prototype._init.call(this, {
            reactive:       true,
            can_focus:      true,
            track_hover:    true
        });

        this.actor.add_actor(new St.Icon({
            icon_name:      'system-shutdown',
            icon_type:      St.IconType.SYMBOLIC,
            style_class:    'system-status-icon'
        }));

        this.actor.add_style_class_name('panel-status-button');
        
        this.actor.has_tooltip = true;
        this.actor.tooltip_text = _("Shutdown");

        this.actor.connect('button-press-event', Lang.bind(this, function(){ _Session.ShutdownRemote(); }));

        Main.panel._insertStatusItem(this.actor, 10);
        Main.panel._statusArea[ROLE] = this;
    },

    destroy: function() {
        Main.panel._statusArea[ROLE] = null;

        this.actor._delegate = null;
        this.actor.destroy();
        this.actor.emit('destroy');
    }
};



function init() {	
}

function enable() {
	userMenuButton.actor.hide();
	ShutdownBTN = new ShutdownButton();
}

function disable() {
	userMenuButton.actor.show();
	ShutdownBTN.destroy();
}
